import { EventEmitter, OnInit, Signal, TemplateRef } from '@angular/core';
import { ThyBoardVirtualScrolledIndexChangeEvent, ThyBoardCard, ThyBoardEntry, ThyBoardLane } from './entities';
import * as i0 from "@angular/core";
export declare class ThyBoardComponent implements OnInit {
    /**
     * 卡片展示模板
     * @type TemplateRef
     */
    cardTemplateRef: Signal<TemplateRef<any>>;
    /**
     * 栏展示模板
     * @type TemplateRef
     */
    laneTemplateRef: TemplateRef<any> | null;
    /**
     * header 展示模板
     * @type TemplateRef
     */
    headerTemplateRef: TemplateRef<any> | null;
    /**
     * 泳道列表
     * @default []
     * @type ThyBoardLane[]
     */
    thyLanes: import("@angular/core").InputSignal<ThyBoardLane[]>;
    /**
     * 栏列表
     * @type ThyBoardEntry[]
     */
    thyEntries: import("@angular/core").InputSignal<ThyBoardEntry[]>;
    /**
     * 卡片列表
     * @type ThyBoardCard[]
     */
    thyCards: import("@angular/core").InputSignal<ThyBoardCard[]>;
    /**
     * 是否展示泳道
     * @default false
     * @type boolean
     */
    thyShowLane: import("@angular/core").InputSignal<boolean>;
    /**
     * 是否开启虚拟滚动
     * @default false
     * @type boolean
     */
    thyVirtualScroll: boolean;
    /**
     * 是否支持排序,开启后支持同栏排序
     * @default false
     * @type boolean
     */
    thySortable: boolean;
    /**
     * 是否支持拖动，变更栏和泳道
     * @default false
     * @type boolean
     */
    thyMovable: boolean;
    /**
     * 开启虚拟滚动后，滚动后触发时间，可用于加载数据
     */
    virtualScrolledIndexChange: EventEmitter<ThyBoardVirtualScrolledIndexChangeEvent>;
    /**
     * 展开收起泳道事件
     */
    expandLane: EventEmitter<{
        lane: ThyBoardLane;
        expanded: boolean;
    }>;
    /**
     * 拖拽后触发事件
     */
    droppableChange: EventEmitter<boolean>;
    isExpandAll: boolean;
    lanesWithEntriesAndCards: Signal<ThyBoardLane[]>;
    entriesWithCards: Signal<ThyBoardEntry[]>;
    constructor();
    ngOnInit(): void;
    private buildCardsMap;
    private buildEntriesWithCardsByLanes;
    private buildEntriesWithCards;
    private buildLanesWithEntriesAndCards;
    expandAll(event: boolean): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<ThyBoardComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<ThyBoardComponent, "thy-board", never, { "thyLanes": { "alias": "thyLanes"; "required": false; "isSignal": true; }; "thyEntries": { "alias": "thyEntries"; "required": true; "isSignal": true; }; "thyCards": { "alias": "thyCards"; "required": true; "isSignal": true; }; "thyShowLane": { "alias": "thyShowLane"; "required": false; "isSignal": true; }; "thyVirtualScroll": { "alias": "thyVirtualScroll"; "required": false; }; "thySortable": { "alias": "thySortable"; "required": false; }; "thyMovable": { "alias": "thyMovable"; "required": false; }; }, { "virtualScrolledIndexChange": "virtualScrolledIndexChange"; "expandLane": "expandLane"; "droppableChange": "droppableChange"; }, ["cardTemplateRef", "laneTemplateRef", "headerTemplateRef"], never, true, never>;
    static ngAcceptInputType_thyVirtualScroll: unknown;
    static ngAcceptInputType_thySortable: unknown;
    static ngAcceptInputType_thyMovable: unknown;
}
//# sourceMappingURL=board.component.d.ts.map