import { EventEmitter, OnChanges, SimpleChanges, NgZone, ElementRef, AfterViewInit, OnDestroy } from '@angular/core';
import { ChangeDetectorRef, OnInit } from '@angular/core';
import { GridsterConfig } from 'angular-gridster2';
import { ThyWidgetItem, WidgetGridsterItem, ThyWidgetVieOutletWithContext, ThyWidgetViewOutlet } from './dashboard.class';
import { Observable } from 'rxjs';
import * as i0 from "@angular/core";
export declare class ThyDashboardComponent implements OnInit, OnChanges, AfterViewInit, OnDestroy {
    private cdr;
    private ngZone;
    /**
     * 仪表盘部件对应组件或模版映射
     */
    thyWidgetViews: Record<string, ThyWidgetViewOutlet | ThyWidgetVieOutletWithContext>;
    /**
     * 仪表盘部件是否允许拖拽
     */
    thyDraggable: boolean;
    /**
     * 仪表盘部件数据
     */
    set thyWidgets(value: ThyWidgetItem[]);
    /**
     * 部件变更
     */
    thyWidgetsChange: EventEmitter<ThyWidgetItem[]>;
    /**
     * 仪表盘整体大小发生变化
     */
    thyResizeChange: EventEmitter<void>;
    gridster: ElementRef<HTMLElement>;
    widgetGridsterItems: WidgetGridsterItem[];
    private widgets;
    private ngUnsubscribe$;
    config: GridsterConfig;
    constructor(cdr: ChangeDetectorRef, ngZone: NgZone);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    trackBy(index: number, item: WidgetGridsterItem): string | number;
    createResizeObserver(element: HTMLElement): Observable<unknown>;
    private buildWidgetGridsterItems;
    private setDraggable;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<ThyDashboardComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<ThyDashboardComponent, "thy-dashboard", never, { "thyWidgetViews": { "alias": "thyWidgetViews"; "required": false; }; "thyDraggable": { "alias": "thyDraggable"; "required": false; }; "thyWidgets": { "alias": "thyWidgets"; "required": false; }; }, { "thyWidgetsChange": "thyWidgetsChange"; "thyResizeChange": "thyResizeChange"; }, never, never, true, never>;
}
//# sourceMappingURL=dashboard.component.d.ts.map