import { ThySharedModule } from 'ngx-tethys/shared';
import { ThyActionModule } from 'ngx-tethys/action';
import { NgTemplateOutlet, NgClass, CommonModule } from '@angular/common';
import * as i0 from '@angular/core';
import { input, EventEmitter, booleanAttribute, Component, ChangeDetectionStrategy, Input, Output, contentChild, computed, ContentChild, NgModule } from '@angular/core';
import { ThyIcon, ThyIconModule } from 'ngx-tethys/icon';
import { ThyTooltipDirective, ThyTooltipModule } from 'ngx-tethys/tooltip';
import { ThyFlexibleText } from 'ngx-tethys/flexible-text';
import * as i1 from '@angular/cdk/scrolling';
import { ScrollingModule } from '@angular/cdk/scrolling';
import * as i2 from '@angular/cdk-experimental/scrolling';
import { ScrollingModule as ScrollingModule$1 } from '@angular/cdk-experimental/scrolling';
import { ThyFlexItem } from 'ngx-tethys/grid';

class ThyBoardHeaderComponent {
    constructor() {
        this.entries = input.required();
        this.hasLane = false;
        this.isExpandAll = true;
        this.headerTemplateRef = null;
        this.expandAll = new EventEmitter();
        this.isFullscreen = false;
    }
    ngOnInit() { }
    expandAllLane() {
        this.isExpandAll = !this.isExpandAll;
        this.expandAll.emit(this.isExpandAll);
    }
    existFullscreen() { }
    enterFullscreen() {
        this.isExpandAll = !this.isExpandAll;
        this.expandAll.emit(this.isExpandAll);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.2.3", ngImport: i0, type: ThyBoardHeaderComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "17.2.3", type: ThyBoardHeaderComponent, isStandalone: true, selector: "thy-board-header", inputs: { entries: { classPropertyName: "entries", publicName: "entries", isSignal: true, isRequired: true, transformFunction: null }, hasLane: { classPropertyName: "hasLane", publicName: "hasLane", isSignal: false, isRequired: false, transformFunction: booleanAttribute }, isExpandAll: { classPropertyName: "isExpandAll", publicName: "isExpandAll", isSignal: false, isRequired: false, transformFunction: null }, headerTemplateRef: { classPropertyName: "headerTemplateRef", publicName: "headerTemplateRef", isSignal: false, isRequired: false, transformFunction: null } }, outputs: { expandAll: "expandAll" }, host: { classAttribute: "thy-board-groups-header" }, ngImport: i0, template: "<div class=\"states\">\n  @if (hasLane) {\n  <div class=\"state d-flex align-items-center\">\n    <a href=\"javascript:;\" class=\"link-muted pr-2\" (click)=\"expandAllLane()\" [thyTooltip]=\"isExpandAll ? '\u5168\u90E8\u6536\u8D77' : '\u5168\u90E8\u5C55\u5F00'\">\n      <thy-icon [thyIconName]=\"isExpandAll ? 'stow' : 'open'\"></thy-icon>\n    </a>\n\n    @if (headerTemplateRef) {\n    <ng-template [ngTemplateOutlet]=\"headerTemplateRef\"></ng-template>\n    } @else {\n    <span>\u6CF3\u9053</span>\n    }\n  </div>\n  } @for (entry of entries(); track entry._id) {\n  <div class=\"state d-flex align-items-center\">\n    @if (headerTemplateRef) {\n    <ng-template [ngTemplateOutlet]=\"headerTemplateRef\" [ngTemplateOutletContext]=\"{ entry: entry, $implicit: entry }\"></ng-template>\n    } @else {\n    <div class=\"text-truncate\">\n      <span thyFlexibleText [thyTooltipContent]=\"entry.name\"> {{ entry.name }}</span>\n    </div>\n    <div class=\"flex-fill\">\n      <span class=\"mx-1\">\u00B7</span>\n      <span>{{ entry.cards?.length || 0 }}</span>\n    </div>\n    }\n  </div>\n  }\n</div>\n", dependencies: [{ kind: "component", type: ThyFlexibleText, selector: "thy-flexible-text,[thyFlexibleText]", inputs: ["thyTooltipTrigger", "thyContainerClass", "thyTooltipContent", "thyTooltipPlacement", "thyTooltipOffset"], exportAs: ["thyFlexibleText"] }, { kind: "component", type: ThyIcon, selector: "thy-icon, [thy-icon]", inputs: ["thyIconType", "thyTwotoneColor", "thyIconName", "thyIconRotate", "thyIconSet", "thyIconLegging", "thyIconLinearGradient"] }, { kind: "directive", type: ThyTooltipDirective, selector: "[thyTooltip],[thy-tooltip]", inputs: ["thyTooltip", "thyTooltipPlacement", "thyTooltipClass", "thyTooltipShowDelay", "thyTooltipHideDelay", "thyTooltipTrigger", "thyTooltipDisabled", "thyTooltipTemplateContext", "thyTooltipOffset", "thyTooltipPin"], exportAs: ["thyTooltip"] }, { kind: "directive", type: NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.2.3", ngImport: i0, type: ThyBoardHeaderComponent, decorators: [{
            type: Component,
            args: [{ selector: 'thy-board-header', standalone: true, changeDetection: ChangeDetectionStrategy.OnPush, imports: [ThyFlexibleText, ThyIcon, ThyTooltipDirective, NgTemplateOutlet], host: {
                        class: 'thy-board-groups-header'
                    }, template: "<div class=\"states\">\n  @if (hasLane) {\n  <div class=\"state d-flex align-items-center\">\n    <a href=\"javascript:;\" class=\"link-muted pr-2\" (click)=\"expandAllLane()\" [thyTooltip]=\"isExpandAll ? '\u5168\u90E8\u6536\u8D77' : '\u5168\u90E8\u5C55\u5F00'\">\n      <thy-icon [thyIconName]=\"isExpandAll ? 'stow' : 'open'\"></thy-icon>\n    </a>\n\n    @if (headerTemplateRef) {\n    <ng-template [ngTemplateOutlet]=\"headerTemplateRef\"></ng-template>\n    } @else {\n    <span>\u6CF3\u9053</span>\n    }\n  </div>\n  } @for (entry of entries(); track entry._id) {\n  <div class=\"state d-flex align-items-center\">\n    @if (headerTemplateRef) {\n    <ng-template [ngTemplateOutlet]=\"headerTemplateRef\" [ngTemplateOutletContext]=\"{ entry: entry, $implicit: entry }\"></ng-template>\n    } @else {\n    <div class=\"text-truncate\">\n      <span thyFlexibleText [thyTooltipContent]=\"entry.name\"> {{ entry.name }}</span>\n    </div>\n    <div class=\"flex-fill\">\n      <span class=\"mx-1\">\u00B7</span>\n      <span>{{ entry.cards?.length || 0 }}</span>\n    </div>\n    }\n  </div>\n  }\n</div>\n" }]
        }], ctorParameters: () => [], propDecorators: { hasLane: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], isExpandAll: [{
                type: Input
            }], headerTemplateRef: [{
                type: Input
            }], expandAll: [{
                type: Output
            }] } });

class ThyBoardEntryComponent {
    constructor() {
        this.hasLane = false;
        this.virtualScroll = false;
        this.cardTemplateRef = null;
        this.entryBodyFooter = null;
        this.cdkDropListEnterPredicate = () => { };
    }
    ngOnInit() { }
    scrolledIndexChange() { }
    // drop(event) {}
    trackByFn(index, item) {
        return item._id || index;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.2.3", ngImport: i0, type: ThyBoardEntryComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "17.2.3", type: ThyBoardEntryComponent, isStandalone: true, selector: "thy-board-entry", inputs: { entry: "entry", lane: "lane", hasLane: "hasLane", virtualScroll: ["virtualScroll", "virtualScroll", booleanAttribute], cardTemplateRef: "cardTemplateRef", entryBodyFooter: "entryBodyFooter" }, host: { classAttribute: "thy-entry-container" }, ngImport: i0, template: "<div class=\"entry-body\">\n  <div class=\"entry-cards\">\n    @if(virtualScroll) {\n    <!-- \u5F00\u542F\u865A\u62DF\u6EDA\u52A8 -->\n    @if(!hasLane){\n    <!-- \u5355\u6CF3\u9053 -->\n    <cdk-virtual-scroll-viewport autosize [minBufferPx]=\"500\" [maxBufferPx]=\"1000\" thyFlexItem=\"auto\">\n      <div *cdkVirtualFor=\"let card of entry.cards; trackBy: trackByFn\" class=\"entry-card\">\n        <ng-template [ngTemplateOutlet]=\"cardTemplateRef\" [ngTemplateOutletContext]=\"{ entry: entry, $implicit: card }\"></ng-template>\n      </div>\n    </cdk-virtual-scroll-viewport>\n    }@else { @for (card of entry.cards; track card._id) {\n    <div id=\"current-card\" class=\"entry-card\">\n      <!-- <div> -->\n      <ng-template [ngTemplateOutlet]=\"cardTemplateRef\" [ngTemplateOutletContext]=\"{ entry: entry, $implicit: card }\"></ng-template>\n      <!-- </div> -->\n    </div>\n    }\n    <!-- \u591A\u6CF3\u9053 -->\n    <!-- <cdk-virtual-scroll-viewport\n      entry\n      [minBufferPx]=\"500\"\n      [maxBufferPx]=\"1000\"\n      [defaultCardSize]=\"112\"\n      (scrolledIndexChange)=\"scrolledIndexChange($event)\"\n      thyFlexItem=\"auto\"\n      class=\"entry-viewport flex-shrink-0\"\n    >\n      <div\n        *cdkVirtualFor=\"let card of entry.cards; trackBy: trackByFn; last as isLast\"\n        cdkDropList\n        [cdkDropListAutoScrollStep]=\"5\"\n        thyDragDrop\n        [cdkDropListData]=\"entry.cards\"\n        id=\"current-work-items\"\n        (cdkDropListDropped)=\"drop($event)\"\n        [cdkDropListEnterPredicate]=\"cdkDropListEnterPredicate\"\n        class=\"entry-work-item\"\n      >\n        <agile-work-item-card\n          class=\"agile\"\n          *ngIf=\"workItem.type !== 'skeleton'\"\n          cdkDrag\n          [cdkDragData]=\"workItem\"\n          (cdkDragStarted)=\"cdkDragStarted($event)\"\n          [cdkDragDisabled]=\"!(workItem.permissions | hasChangeWorkItemStatePermission : workItem.refs?.type?.group)\"\n          [workItem]=\"workItem\"\n          [showPropertyConfig]=\"showPropertyConfig\"\n        ></agile-work-item-card>\n        <pjm-work-item-card-skeleton *ngIf=\"workItem.type === 'skeleton'\"></pjm-work-item-card-skeleton>\n      </div>\n    </cdk-virtual-scroll-viewport> -->\n\n    } } @else {\n    <!-- \u4E0D\u5F00\u542F\u865A\u62DF\u6EDA\u52A8 -->\n    @for (card of entry.cards; track card._id) {\n    <div class=\"entry-card\">\n      <!-- <div> -->\n      <ng-template [ngTemplateOutlet]=\"cardTemplateRef\" [ngTemplateOutletContext]=\"{ entry: entry, $implicit: card }\"></ng-template>\n      <!-- </div> -->\n    </div>\n    } } @if (entryBodyFooter) {\n    <ng-template [ngTemplateOutlet]=\"entryBodyFooter\" [ngTemplateOutletContext]=\"{ entry: entry }\"></ng-template>\n    }\n  </div>\n</div>\n", dependencies: [{ kind: "directive", type: NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "ngmodule", type: ScrollingModule }, { kind: "directive", type: i1.CdkVirtualForOf, selector: "[cdkVirtualFor][cdkVirtualForOf]", inputs: ["cdkVirtualForOf", "cdkVirtualForTrackBy", "cdkVirtualForTemplate", "cdkVirtualForTemplateCacheSize"] }, { kind: "component", type: i1.CdkVirtualScrollViewport, selector: "cdk-virtual-scroll-viewport", inputs: ["orientation", "appendOnly"], outputs: ["scrolledIndexChange"] }, { kind: "ngmodule", type: ScrollingModule$1 }, { kind: "directive", type: i2.CdkAutoSizeVirtualScroll, selector: "cdk-virtual-scroll-viewport[autosize]", inputs: ["minBufferPx", "maxBufferPx"] }, { kind: "directive", type: ThyFlexItem, selector: "[thyFlexItem]", inputs: ["thyFlexItem", "thyGrow", "thyShrink", "thyBasis"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.2.3", ngImport: i0, type: ThyBoardEntryComponent, decorators: [{
            type: Component,
            args: [{ selector: 'thy-board-entry', standalone: true, changeDetection: ChangeDetectionStrategy.OnPush, imports: [NgTemplateOutlet, ScrollingModule, ScrollingModule$1, ThyFlexItem], host: {
                        class: 'thy-entry-container'
                    }, template: "<div class=\"entry-body\">\n  <div class=\"entry-cards\">\n    @if(virtualScroll) {\n    <!-- \u5F00\u542F\u865A\u62DF\u6EDA\u52A8 -->\n    @if(!hasLane){\n    <!-- \u5355\u6CF3\u9053 -->\n    <cdk-virtual-scroll-viewport autosize [minBufferPx]=\"500\" [maxBufferPx]=\"1000\" thyFlexItem=\"auto\">\n      <div *cdkVirtualFor=\"let card of entry.cards; trackBy: trackByFn\" class=\"entry-card\">\n        <ng-template [ngTemplateOutlet]=\"cardTemplateRef\" [ngTemplateOutletContext]=\"{ entry: entry, $implicit: card }\"></ng-template>\n      </div>\n    </cdk-virtual-scroll-viewport>\n    }@else { @for (card of entry.cards; track card._id) {\n    <div id=\"current-card\" class=\"entry-card\">\n      <!-- <div> -->\n      <ng-template [ngTemplateOutlet]=\"cardTemplateRef\" [ngTemplateOutletContext]=\"{ entry: entry, $implicit: card }\"></ng-template>\n      <!-- </div> -->\n    </div>\n    }\n    <!-- \u591A\u6CF3\u9053 -->\n    <!-- <cdk-virtual-scroll-viewport\n      entry\n      [minBufferPx]=\"500\"\n      [maxBufferPx]=\"1000\"\n      [defaultCardSize]=\"112\"\n      (scrolledIndexChange)=\"scrolledIndexChange($event)\"\n      thyFlexItem=\"auto\"\n      class=\"entry-viewport flex-shrink-0\"\n    >\n      <div\n        *cdkVirtualFor=\"let card of entry.cards; trackBy: trackByFn; last as isLast\"\n        cdkDropList\n        [cdkDropListAutoScrollStep]=\"5\"\n        thyDragDrop\n        [cdkDropListData]=\"entry.cards\"\n        id=\"current-work-items\"\n        (cdkDropListDropped)=\"drop($event)\"\n        [cdkDropListEnterPredicate]=\"cdkDropListEnterPredicate\"\n        class=\"entry-work-item\"\n      >\n        <agile-work-item-card\n          class=\"agile\"\n          *ngIf=\"workItem.type !== 'skeleton'\"\n          cdkDrag\n          [cdkDragData]=\"workItem\"\n          (cdkDragStarted)=\"cdkDragStarted($event)\"\n          [cdkDragDisabled]=\"!(workItem.permissions | hasChangeWorkItemStatePermission : workItem.refs?.type?.group)\"\n          [workItem]=\"workItem\"\n          [showPropertyConfig]=\"showPropertyConfig\"\n        ></agile-work-item-card>\n        <pjm-work-item-card-skeleton *ngIf=\"workItem.type === 'skeleton'\"></pjm-work-item-card-skeleton>\n      </div>\n    </cdk-virtual-scroll-viewport> -->\n\n    } } @else {\n    <!-- \u4E0D\u5F00\u542F\u865A\u62DF\u6EDA\u52A8 -->\n    @for (card of entry.cards; track card._id) {\n    <div class=\"entry-card\">\n      <!-- <div> -->\n      <ng-template [ngTemplateOutlet]=\"cardTemplateRef\" [ngTemplateOutletContext]=\"{ entry: entry, $implicit: card }\"></ng-template>\n      <!-- </div> -->\n    </div>\n    } } @if (entryBodyFooter) {\n    <ng-template [ngTemplateOutlet]=\"entryBodyFooter\" [ngTemplateOutletContext]=\"{ entry: entry }\"></ng-template>\n    }\n  </div>\n</div>\n" }]
        }], ctorParameters: () => [], propDecorators: { entry: [{
                type: Input,
                args: [{ required: true }]
            }], lane: [{
                type: Input
            }], hasLane: [{
                type: Input
            }], virtualScroll: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], cardTemplateRef: [{
                type: Input
            }], entryBodyFooter: [{
                type: Input
            }] } });

class ThyBoardLaneComponent {
    constructor() {
        this.isBatchOperation = false;
        this.swimlaneLength = 0;
        this.entries = input.required();
        this.isExpanded = true;
        this.hasLane = false;
        this.virtualScroll = false;
        this.laneTemplateRef = null;
        this.cardTemplateRef = null;
    }
    ngOnInit() { }
    switchSwimlaneExpand() { }
    expand() {
        this.isExpanded = !this.isExpanded;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.2.3", ngImport: i0, type: ThyBoardLaneComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "17.2.3", type: ThyBoardLaneComponent, isStandalone: true, selector: "thy-board-lane", inputs: { lane: { classPropertyName: "lane", publicName: "lane", isSignal: false, isRequired: false, transformFunction: null }, entries: { classPropertyName: "entries", publicName: "entries", isSignal: true, isRequired: true, transformFunction: null }, isExpanded: { classPropertyName: "isExpanded", publicName: "isExpanded", isSignal: false, isRequired: false, transformFunction: booleanAttribute }, hasLane: { classPropertyName: "hasLane", publicName: "hasLane", isSignal: false, isRequired: false, transformFunction: booleanAttribute }, virtualScroll: { classPropertyName: "virtualScroll", publicName: "virtualScroll", isSignal: false, isRequired: false, transformFunction: booleanAttribute }, laneTemplateRef: { classPropertyName: "laneTemplateRef", publicName: "laneTemplateRef", isSignal: false, isRequired: false, transformFunction: null }, cardTemplateRef: { classPropertyName: "cardTemplateRef", publicName: "cardTemplateRef", isSignal: false, isRequired: false, transformFunction: null } }, host: { classAttribute: "thy-board-lane-container" }, ngImport: i0, template: "@if(hasLane){\n<div class=\"board-lane-header-container d-flex\" [class.board-lane-header-expanded]=\"isExpanded\">\n  <div class=\"board-lane-header\">\n    <thy-icon\n      thyIconName=\"angle-down\"\n      class=\"lane-expand-icon mr-2\"\n      [class.lane-expand-icon-collapsed]=\"!isExpanded\"\n      (click)=\"expand()\"\n    ></thy-icon>\n\n    @if(laneTemplateRef) {\n\n    <ng-template\n      [ngTemplateOutlet]=\"laneTemplateRef\"\n      [ngTemplateOutletContext]=\"{ lane: lane, $implicit: lane, isExpanded: isExpanded }\"\n    ></ng-template>\n    } @else{\n    <div class=\"d-flex justify-content-between text-secondary flex-grow-1 type-container\">\n      <span thyFlexibleText [thyTooltipContent]=\"lane!.name\">\n        <span>{{ lane?.name }}</span>\n      </span>\n      @if(isExpanded) {\n      <span class=\"text-muted flex-shrink-0\"\n        ><span class=\"text-secondary mr-1\">{{ lane?.cards?.length || 0 }}</span\n        >\u4E2A</span\n      >\n      }\n    </div>\n    }\n  </div>\n</div>\n}\n\n<div class=\"board-lane-body\" cdkDropListGroup [class.board-no-lane-body]=\"!hasLane\">\n  @if(hasLane) { @for (entry of lane?.entries; track entry._id) {\n  <div\n    class=\"board-lane-body-entry\"\n    [class.board-lane-body-entry-is-empty]=\"isExpanded && lane?.cards?.length === 0\"\n    [class.board-lane-body-entry-is-collapsed]=\"!isExpanded\"\n  >\n    @if(isExpanded){\n    <thy-board-entry\n      [hasLane]=\"hasLane\"\n      [virtualScroll]=\"virtualScroll\"\n      [entry]=\"entry\"\n      [cardTemplateRef]=\"cardTemplateRef\"\n      [lane]=\"lane\"\n    ></thy-board-entry>\n    }@else {\n    <div class=\"text-muted mx-5 text-truncate\">\n      <span class=\"text-secondary mr-1\">{{ entry.cards!.length }}</span\n      >\u4E2A{{ entry.name }}\n    </div>\n\n    }\n  </div>\n  } } @else{ @for (entry of entries(); track entry._id) {\n  <div class=\"board-lane-body-entry\">\n    <thy-board-entry [hasLane]=\"hasLane\" [virtualScroll]=\"virtualScroll\" [entry]=\"entry\" [cardTemplateRef]=\"cardTemplateRef\">\n    </thy-board-entry>\n  </div>\n  } }\n</div>\n\n<ng-template #unGroupHeader>\n  <span>{{ lane?.name }}</span>\n</ng-template>\n", dependencies: [{ kind: "directive", type: NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "component", type: ThyIcon, selector: "thy-icon, [thy-icon]", inputs: ["thyIconType", "thyTwotoneColor", "thyIconName", "thyIconRotate", "thyIconSet", "thyIconLegging", "thyIconLinearGradient"] }, { kind: "component", type: ThyFlexibleText, selector: "thy-flexible-text,[thyFlexibleText]", inputs: ["thyTooltipTrigger", "thyContainerClass", "thyTooltipContent", "thyTooltipPlacement", "thyTooltipOffset"], exportAs: ["thyFlexibleText"] }, { kind: "component", type: ThyBoardEntryComponent, selector: "thy-board-entry", inputs: ["entry", "lane", "hasLane", "virtualScroll", "cardTemplateRef", "entryBodyFooter"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.2.3", ngImport: i0, type: ThyBoardLaneComponent, decorators: [{
            type: Component,
            args: [{ selector: 'thy-board-lane', standalone: true, changeDetection: ChangeDetectionStrategy.OnPush, imports: [NgClass, NgTemplateOutlet, ThyIcon, ThyFlexibleText, ThyBoardEntryComponent], host: {
                        class: 'thy-board-lane-container'
                    }, template: "@if(hasLane){\n<div class=\"board-lane-header-container d-flex\" [class.board-lane-header-expanded]=\"isExpanded\">\n  <div class=\"board-lane-header\">\n    <thy-icon\n      thyIconName=\"angle-down\"\n      class=\"lane-expand-icon mr-2\"\n      [class.lane-expand-icon-collapsed]=\"!isExpanded\"\n      (click)=\"expand()\"\n    ></thy-icon>\n\n    @if(laneTemplateRef) {\n\n    <ng-template\n      [ngTemplateOutlet]=\"laneTemplateRef\"\n      [ngTemplateOutletContext]=\"{ lane: lane, $implicit: lane, isExpanded: isExpanded }\"\n    ></ng-template>\n    } @else{\n    <div class=\"d-flex justify-content-between text-secondary flex-grow-1 type-container\">\n      <span thyFlexibleText [thyTooltipContent]=\"lane!.name\">\n        <span>{{ lane?.name }}</span>\n      </span>\n      @if(isExpanded) {\n      <span class=\"text-muted flex-shrink-0\"\n        ><span class=\"text-secondary mr-1\">{{ lane?.cards?.length || 0 }}</span\n        >\u4E2A</span\n      >\n      }\n    </div>\n    }\n  </div>\n</div>\n}\n\n<div class=\"board-lane-body\" cdkDropListGroup [class.board-no-lane-body]=\"!hasLane\">\n  @if(hasLane) { @for (entry of lane?.entries; track entry._id) {\n  <div\n    class=\"board-lane-body-entry\"\n    [class.board-lane-body-entry-is-empty]=\"isExpanded && lane?.cards?.length === 0\"\n    [class.board-lane-body-entry-is-collapsed]=\"!isExpanded\"\n  >\n    @if(isExpanded){\n    <thy-board-entry\n      [hasLane]=\"hasLane\"\n      [virtualScroll]=\"virtualScroll\"\n      [entry]=\"entry\"\n      [cardTemplateRef]=\"cardTemplateRef\"\n      [lane]=\"lane\"\n    ></thy-board-entry>\n    }@else {\n    <div class=\"text-muted mx-5 text-truncate\">\n      <span class=\"text-secondary mr-1\">{{ entry.cards!.length }}</span\n      >\u4E2A{{ entry.name }}\n    </div>\n\n    }\n  </div>\n  } } @else{ @for (entry of entries(); track entry._id) {\n  <div class=\"board-lane-body-entry\">\n    <thy-board-entry [hasLane]=\"hasLane\" [virtualScroll]=\"virtualScroll\" [entry]=\"entry\" [cardTemplateRef]=\"cardTemplateRef\">\n    </thy-board-entry>\n  </div>\n  } }\n</div>\n\n<ng-template #unGroupHeader>\n  <span>{{ lane?.name }}</span>\n</ng-template>\n" }]
        }], ctorParameters: () => [], propDecorators: { lane: [{
                type: Input
            }], isExpanded: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], hasLane: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], virtualScroll: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], laneTemplateRef: [{
                type: Input
            }], cardTemplateRef: [{
                type: Input
            }] } });

const EMPTY_OBJECT_ID_STR = `000000000000000000000000`;

class ThyBoardComponent {
    constructor() {
        /**
         * 卡片展示模板
         * @type TemplateRef
         */
        this.cardTemplateRef = contentChild.required('card');
        /**
         * 栏展示模板
         * @type TemplateRef
         */
        this.laneTemplateRef = null;
        /**
         * header 展示模板
         * @type TemplateRef
         */
        this.headerTemplateRef = null;
        /**
         * 泳道列表
         * @default []
         * @type ThyBoardLane[]
         */
        this.thyLanes = input([]);
        /**
         * 栏列表
         * @type ThyBoardEntry[]
         */
        this.thyEntries = input.required();
        /**
         * 卡片列表
         * @type ThyBoardCard[]
         */
        this.thyCards = input.required();
        /**
         * 是否展示泳道
         * @default false
         * @type boolean
         */
        this.thyShowLane = input(false);
        /**
         * 是否开启虚拟滚动
         * @default false
         * @type boolean
         */
        this.thyVirtualScroll = false;
        /**
         * 是否支持排序,开启后支持同栏排序
         * @default false
         * @type boolean
         */
        this.thySortable = false;
        /**
         * 是否支持拖动，变更栏和泳道
         * @default false
         * @type boolean
         */
        this.thyMovable = false;
        // @Input() dragStartFn: (card: ThyBoardCard) => Observable<[]>;
        // @Input() dragDropFn: (data: { card: ThyBoardCard }) => Observable<any>;
        /**
         * 开启虚拟滚动后，滚动后触发时间，可用于加载数据
         */
        this.virtualScrolledIndexChange = new EventEmitter();
        /**
         * 展开收起泳道事件
         */
        this.expandLane = new EventEmitter();
        /**
         * 拖拽后触发事件
         */
        this.droppableChange = new EventEmitter();
        this.isExpandAll = true;
        this.lanesWithEntriesAndCards = computed(() => {
            const entries = this.thyEntries();
            const cards = this.thyCards();
            const lanes = this.thyLanes();
            return this.buildLanesWithEntriesAndCards(lanes, entries, cards);
        });
        this.entriesWithCards = computed(() => {
            const lanesWithEntriesAndCards = this.lanesWithEntriesAndCards();
            const entries = this.thyEntries();
            return this.buildEntriesWithCardsByLanes(lanesWithEntriesAndCards, entries);
        });
    }
    ngOnInit() { }
    buildCardsMap(cards) {
        const cardsMapByEntryId = {};
        (cards || []).forEach((card) => {
            cardsMapByEntryId[card.entryId] = cardsMapByEntryId[card.entryId] ? cardsMapByEntryId[card.entryId].concat([card]) : [card];
        });
        return cardsMapByEntryId;
    }
    buildEntriesWithCardsByLanes(lanes, entries) {
        const entriesMapById = {};
        (entries || []).forEach((entry) => {
            entriesMapById[entry._id] = entry;
            entriesMapById[entry._id].cards = [];
        });
        (lanes || []).forEach((lane) => {
            lane.entries.forEach((entry) => {
                entriesMapById[entry._id].cards = (entriesMapById[entry._id].cards || []).concat(entry.cards || []);
            });
        });
        return entries;
    }
    buildEntriesWithCards(cards, entries) {
        const cardsMapByEntryId = this.buildCardsMap(cards);
        return (entries || []).map((entry) => {
            return {
                ...entry,
                cards: cardsMapByEntryId[entry._id] || []
            };
        });
    }
    buildLanesWithEntriesAndCards(lanes, entries, cards) {
        const unGroup = {
            _id: EMPTY_OBJECT_ID_STR,
            name: '未分组',
            cards: []
        };
        const lanesMapById = {};
        (lanes || []).forEach((lane) => {
            lane.cards = [];
            lanesMapById[lane._id] = lane;
        });
        (cards || []).forEach((card) => {
            let lane = lanesMapById[card.laneId];
            if (lane) {
                lane.cards = lane.cards?.concat(card);
            }
            else {
                unGroup.cards = unGroup.cards?.concat(card);
            }
        });
        lanes = unGroup.cards.length > 0 ? [...lanes, unGroup] : [...lanes];
        return lanes.map((lane) => {
            if (!lane.cards) {
                lane.cards = [];
            }
            return {
                ...lane,
                entries: this.buildEntriesWithCards(lane.cards, entries)
            };
        });
    }
    expandAll(event) {
        this.isExpandAll = event;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.2.3", ngImport: i0, type: ThyBoardComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "17.2.3", type: ThyBoardComponent, isStandalone: true, selector: "thy-board", inputs: { thyLanes: { classPropertyName: "thyLanes", publicName: "thyLanes", isSignal: true, isRequired: false, transformFunction: null }, thyEntries: { classPropertyName: "thyEntries", publicName: "thyEntries", isSignal: true, isRequired: true, transformFunction: null }, thyCards: { classPropertyName: "thyCards", publicName: "thyCards", isSignal: true, isRequired: true, transformFunction: null }, thyShowLane: { classPropertyName: "thyShowLane", publicName: "thyShowLane", isSignal: true, isRequired: false, transformFunction: null }, thyVirtualScroll: { classPropertyName: "thyVirtualScroll", publicName: "thyVirtualScroll", isSignal: false, isRequired: false, transformFunction: booleanAttribute }, thySortable: { classPropertyName: "thySortable", publicName: "thySortable", isSignal: false, isRequired: false, transformFunction: booleanAttribute }, thyMovable: { classPropertyName: "thyMovable", publicName: "thyMovable", isSignal: false, isRequired: false, transformFunction: booleanAttribute } }, outputs: { virtualScrolledIndexChange: "virtualScrolledIndexChange", expandLane: "expandLane", droppableChange: "droppableChange" }, host: { classAttribute: "thy-board-container" }, queries: [{ propertyName: "cardTemplateRef", first: true, predicate: ["card"], descendants: true, isSignal: true }, { propertyName: "laneTemplateRef", first: true, predicate: ["lane"], descendants: true }, { propertyName: "headerTemplateRef", first: true, predicate: ["header"], descendants: true }], ngImport: i0, template: "<thy-board-header\n  [hasLane]=\"thyShowLane()\"\n  [entries]=\"entriesWithCards()\"\n  [headerTemplateRef]=\"headerTemplateRef\"\n  [isExpandAll]=\"isExpandAll\"\n  (expandAll)=\"expandAll($event)\"\n>\n</thy-board-header>\n<div class=\"board-body\" cdkDropListGroup #boardScrollElement [class.board-single-swimlane]=\"!thyShowLane()\">\n  @if(thyShowLane()) { @for(lane of lanesWithEntriesAndCards(); track lane._id){\n  <thy-board-lane\n    [lane]=\"lane\"\n    [entries]=\"entriesWithCards()\"\n    [hasLane]=\"thyShowLane()\"\n    [virtualScroll]=\"thyVirtualScroll\"\n    [laneTemplateRef]=\"laneTemplateRef\"\n    [cardTemplateRef]=\"cardTemplateRef()\"\n    [isExpanded]=\"isExpandAll\"\n  ></thy-board-lane>\n  } } @else{\n  <thy-board-lane\n    [entries]=\"entriesWithCards()\"\n    [hasLane]=\"thyShowLane()\"\n    [virtualScroll]=\"thyVirtualScroll\"\n    [laneTemplateRef]=\"laneTemplateRef\"\n    [cardTemplateRef]=\"cardTemplateRef()\"\n    [isExpanded]=\"isExpandAll\"\n  ></thy-board-lane>\n  }\n</div>\n", dependencies: [{ kind: "component", type: ThyBoardHeaderComponent, selector: "thy-board-header", inputs: ["entries", "hasLane", "isExpandAll", "headerTemplateRef"], outputs: ["expandAll"] }, { kind: "component", type: ThyBoardLaneComponent, selector: "thy-board-lane", inputs: ["lane", "entries", "isExpanded", "hasLane", "virtualScroll", "laneTemplateRef", "cardTemplateRef"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.2.3", ngImport: i0, type: ThyBoardComponent, decorators: [{
            type: Component,
            args: [{ selector: 'thy-board', standalone: true, changeDetection: ChangeDetectionStrategy.OnPush, imports: [ThyBoardHeaderComponent, ThyBoardLaneComponent, ThyBoardEntryComponent], host: {
                        class: 'thy-board-container'
                    }, template: "<thy-board-header\n  [hasLane]=\"thyShowLane()\"\n  [entries]=\"entriesWithCards()\"\n  [headerTemplateRef]=\"headerTemplateRef\"\n  [isExpandAll]=\"isExpandAll\"\n  (expandAll)=\"expandAll($event)\"\n>\n</thy-board-header>\n<div class=\"board-body\" cdkDropListGroup #boardScrollElement [class.board-single-swimlane]=\"!thyShowLane()\">\n  @if(thyShowLane()) { @for(lane of lanesWithEntriesAndCards(); track lane._id){\n  <thy-board-lane\n    [lane]=\"lane\"\n    [entries]=\"entriesWithCards()\"\n    [hasLane]=\"thyShowLane()\"\n    [virtualScroll]=\"thyVirtualScroll\"\n    [laneTemplateRef]=\"laneTemplateRef\"\n    [cardTemplateRef]=\"cardTemplateRef()\"\n    [isExpanded]=\"isExpandAll\"\n  ></thy-board-lane>\n  } } @else{\n  <thy-board-lane\n    [entries]=\"entriesWithCards()\"\n    [hasLane]=\"thyShowLane()\"\n    [virtualScroll]=\"thyVirtualScroll\"\n    [laneTemplateRef]=\"laneTemplateRef\"\n    [cardTemplateRef]=\"cardTemplateRef()\"\n    [isExpanded]=\"isExpandAll\"\n  ></thy-board-lane>\n  }\n</div>\n" }]
        }], ctorParameters: () => [], propDecorators: { laneTemplateRef: [{
                type: ContentChild,
                args: ['lane']
            }], headerTemplateRef: [{
                type: ContentChild,
                args: ['header']
            }], thyVirtualScroll: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], thySortable: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], thyMovable: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], virtualScrolledIndexChange: [{
                type: Output
            }], expandLane: [{
                type: Output
            }], droppableChange: [{
                type: Output
            }] } });

const TETHYS_MODULES = [ThyTooltipModule, ThyIconModule, ThyActionModule, ThySharedModule];
class ThyProBoardModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.2.3", ngImport: i0, type: ThyProBoardModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "17.2.3", ngImport: i0, type: ThyProBoardModule, imports: [ThyTooltipModule, ThyIconModule, ThyActionModule, ThySharedModule, CommonModule, ThyBoardComponent, ThyBoardLaneComponent, ThyBoardEntryComponent, ThyBoardHeaderComponent], exports: [ThyBoardComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "17.2.3", ngImport: i0, type: ThyProBoardModule, imports: [TETHYS_MODULES, CommonModule, ThyBoardComponent, ThyBoardLaneComponent, ThyBoardEntryComponent, ThyBoardHeaderComponent] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.2.3", ngImport: i0, type: ThyProBoardModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [...TETHYS_MODULES, CommonModule, ThyBoardComponent, ThyBoardLaneComponent, ThyBoardEntryComponent, ThyBoardHeaderComponent],
                    exports: [ThyBoardComponent],
                    providers: []
                }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { EMPTY_OBJECT_ID_STR, ThyBoardComponent, ThyBoardEntryComponent, ThyBoardHeaderComponent, ThyBoardLaneComponent, ThyProBoardModule };
//# sourceMappingURL=tethys-pro-board.mjs.map
