import * as i0 from '@angular/core';
import { Component, ChangeDetectionStrategy, Input, NgModule } from '@angular/core';
import { of, interval } from 'rxjs';
import { take, map, catchError } from 'rxjs/operators';
import * as i1 from 'ngx-tethys/button';
import { ThyButtonModule } from 'ngx-tethys/button';
import { NgIf, CommonModule } from '@angular/common';
import { RouterModule } from '@angular/router';

class ThyCountdownComponent {
    get started() {
        return this.seconds !== 0;
    }
    constructor() {
        this.text = '获取短信验证码';
        this.disabled = false;
        this.sendAction = () => of(false);
        this.seconds = 0;
        this.time = 60;
    }
    ngOnInit() { }
    onClick() {
        if (this.disabled) {
            return;
        }
        this.start();
    }
    start() {
        this.seconds = this.time;
        this.subscription = interval(1000)
            .pipe(take(this.time), map((value) => this.time - 1 - value))
            .subscribe((value) => {
            this.seconds = value;
        });
        if (this.sendAction) {
            this.sendAction()
                .pipe(catchError(() => {
                this.reset();
                return of(null);
            }))
                .subscribe((data) => {
                if (!data) {
                    this.reset();
                }
            });
        }
    }
    reset() {
        this.time = 60;
        this.seconds = 0;
        if (this.subscription) {
            this.subscription.unsubscribe();
        }
    }
    ngOnDestroy() {
        if (this.subscription) {
            this.subscription.unsubscribe();
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.2.3", ngImport: i0, type: ThyCountdownComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "17.2.3", type: ThyCountdownComponent, isStandalone: true, selector: "thy-countdown", inputs: { text: "text", disabled: "disabled", sendAction: "sendAction" }, host: { classAttribute: "thy-countdown" }, ngImport: i0, template: "<ng-container *ngIf=\"seconds === 0; else progress\">\n  <button [disabled]=\"disabled\" thyButton=\"primary\" thySize=\"sm\" (click)=\"onClick()\">\n    {{ text }}\n  </button>\n</ng-container>\n<ng-template #progress>\n  <span class=\"countdown-progress\"\n    >\u5DF2\u53D1\u9001\uFF0C<span class=\"text-primary\">{{ seconds }}</span> \u79D2\u540E\u91CD\u65B0\u83B7\u53D6</span\n  >\n</ng-template>\n", dependencies: [{ kind: "directive", type: NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "ngmodule", type: ThyButtonModule }, { kind: "component", type: i1.ThyButton, selector: "thy-button,[thy-button],[thyButton]", inputs: ["thyButton", "thyType", "thyLoading", "thyLoadingText", "thySize", "thyIcon", "thyBlock"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.2.3", ngImport: i0, type: ThyCountdownComponent, decorators: [{
            type: Component,
            args: [{ selector: 'thy-countdown', changeDetection: ChangeDetectionStrategy.OnPush, host: {
                        class: 'thy-countdown'
                    }, standalone: true, imports: [NgIf, ThyButtonModule], template: "<ng-container *ngIf=\"seconds === 0; else progress\">\n  <button [disabled]=\"disabled\" thyButton=\"primary\" thySize=\"sm\" (click)=\"onClick()\">\n    {{ text }}\n  </button>\n</ng-container>\n<ng-template #progress>\n  <span class=\"countdown-progress\"\n    >\u5DF2\u53D1\u9001\uFF0C<span class=\"text-primary\">{{ seconds }}</span> \u79D2\u540E\u91CD\u65B0\u83B7\u53D6</span\n  >\n</ng-template>\n" }]
        }], ctorParameters: () => [], propDecorators: { text: [{
                type: Input
            }], disabled: [{
                type: Input
            }], sendAction: [{
                type: Input
            }] } });

class ThyProCountdownModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.2.3", ngImport: i0, type: ThyProCountdownModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "17.2.3", ngImport: i0, type: ThyProCountdownModule, imports: [ThyButtonModule, RouterModule, CommonModule, ThyCountdownComponent], exports: [ThyCountdownComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "17.2.3", ngImport: i0, type: ThyProCountdownModule, imports: [ThyButtonModule, RouterModule, CommonModule, ThyCountdownComponent] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.2.3", ngImport: i0, type: ThyProCountdownModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [ThyButtonModule, RouterModule, CommonModule, ThyCountdownComponent],
                    exports: [ThyCountdownComponent],
                    providers: []
                }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { ThyCountdownComponent, ThyProCountdownModule };
//# sourceMappingURL=tethys-pro-countdown.mjs.map
