import * as i1 from 'ngx-tethys/shared';
import { ThySharedModule, ThyViewOutletDirective } from 'ngx-tethys/shared';
import { ThyActionModule } from 'ngx-tethys/action';
import { NgClass, NgIf, NgFor, CommonModule } from '@angular/common';
import * as i0 from '@angular/core';
import { Component, ChangeDetectionStrategy, Input, ContentChild, EventEmitter, ElementRef, Output, ViewChild, NgModule, Directive } from '@angular/core';
import { RouterModule } from '@angular/router';
import { GridType, CompactType, DisplayGrid, GridsterComponent, GridsterItemComponent, GridsterModule } from 'angular-gridster2';
import { ThyIconModule } from 'ngx-tethys/icon';
import { ThyTooltipModule } from 'ngx-tethys/tooltip';
import { debounceTime, takeUntil } from 'rxjs/operators';
import { Subject, of, Observable } from 'rxjs';

class ThyDashboardWidgetHeaderComponent {
    constructor() { }
    ngOnInit() { }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.2.3", ngImport: i0, type: ThyDashboardWidgetHeaderComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "17.2.3", type: ThyDashboardWidgetHeaderComponent, isStandalone: true, selector: "thy-dashboard-widget-header", inputs: { thyTitle: "thyTitle", thyDescription: "thyDescription" }, host: { classAttribute: "thy-dashboard-widget-header" }, queries: [{ propertyName: "operationTemplateRef", first: true, predicate: ["operation"], descendants: true }], ngImport: i0, template: "<div class=\"widget-header-title\" [ngClass]=\"{ 'mb-3': !thyDescription }\">\n  <span class=\"title-text text-truncate\" *thyStringOrTemplateOutlet=\"thyTitle\"></span>\n</div>\n<div *ngIf=\"thyDescription\" class=\"widget-header-description text-truncate\" [ngClass]=\"{ 'mb-3': thyDescription }\">\n  <ng-container *thyStringOrTemplateOutlet=\"thyDescription\"></ng-container>\n</div>\n", dependencies: [{ kind: "directive", type: NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "ngmodule", type: ThySharedModule }, { kind: "directive", type: i1.ThyStringOrTemplateOutletDirective, selector: "[thyStringOrTemplateOutlet]", inputs: ["thyStringOrTemplateOutletContext", "thyStringOrTemplateOutlet"], exportAs: ["thyStringOrTemplateOutlet"] }, { kind: "directive", type: NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.2.3", ngImport: i0, type: ThyDashboardWidgetHeaderComponent, decorators: [{
            type: Component,
            args: [{ selector: 'thy-dashboard-widget-header', changeDetection: ChangeDetectionStrategy.OnPush, host: { class: 'thy-dashboard-widget-header' }, standalone: true, imports: [NgClass, ThySharedModule, NgIf], template: "<div class=\"widget-header-title\" [ngClass]=\"{ 'mb-3': !thyDescription }\">\n  <span class=\"title-text text-truncate\" *thyStringOrTemplateOutlet=\"thyTitle\"></span>\n</div>\n<div *ngIf=\"thyDescription\" class=\"widget-header-description text-truncate\" [ngClass]=\"{ 'mb-3': thyDescription }\">\n  <ng-container *thyStringOrTemplateOutlet=\"thyDescription\"></ng-container>\n</div>\n" }]
        }], ctorParameters: () => [], propDecorators: { thyTitle: [{
                type: Input
            }], thyDescription: [{
                type: Input
            }], operationTemplateRef: [{
                type: ContentChild,
                args: ['operation']
            }] } });

class ThyDashboardWidgetBodyComponent {
    constructor() { }
    ngOnInit() { }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.2.3", ngImport: i0, type: ThyDashboardWidgetBodyComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "17.2.3", type: ThyDashboardWidgetBodyComponent, isStandalone: true, selector: "thy-dashboard-widget-body", host: { classAttribute: "thy-dashboard-widget-body" }, ngImport: i0, template: "<ng-content></ng-content>\n", changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.2.3", ngImport: i0, type: ThyDashboardWidgetBodyComponent, decorators: [{
            type: Component,
            args: [{ selector: 'thy-dashboard-widget-body', changeDetection: ChangeDetectionStrategy.OnPush, host: { class: 'thy-dashboard-widget-body' }, standalone: true, template: "<ng-content></ng-content>\n" }]
        }], ctorParameters: () => [] });

class ThyDashboardComponent {
    /**
     * 仪表盘部件数据
     */
    set thyWidgets(value) {
        this.widgets = value || [];
    }
    constructor(cdr, ngZone) {
        this.cdr = cdr;
        this.ngZone = ngZone;
        /**
         * 仪表盘部件对应组件或模版映射
         */
        this.thyWidgetViews = {};
        /**
         * 仪表盘部件是否允许拖拽
         */
        this.thyDraggable = false;
        /**
         * 部件变更
         */
        this.thyWidgetsChange = new EventEmitter();
        /**
         * 仪表盘整体大小发生变化
         */
        this.thyResizeChange = new EventEmitter();
        this.widgetGridsterItems = [];
        this.ngUnsubscribe$ = new Subject();
        this.config = {
            gridType: GridType.VerticalFixed,
            margin: 8,
            compactType: CompactType.None,
            displayGrid: DisplayGrid.None,
            maxCols: 12,
            minCols: 12,
            fixedRowHeight: 120,
            disableScrollHorizontal: true,
            pushItems: true,
            disablePushOnDrag: true,
            useTransformPositioning: false,
            outerMargin: true,
            itemChangeCallback: (item) => {
                const changedWidget = this.widgets.find((widget) => {
                    return widget._id === item.widget._id;
                });
                if (changedWidget) {
                    changedWidget.position = { x: item.x, y: item.y };
                    changedWidget.size = { cols: item.cols, rows: item.rows };
                    this.thyWidgetsChange.emit(this.widgets);
                }
            }
        };
    }
    ngOnInit() {
        this.setDraggable(this.thyDraggable);
        this.widgetGridsterItems = this.buildWidgetGridsterItems(this.widgets);
        if (this.config.api && this.config.api.resize) {
            this.config.api.resize();
        }
    }
    ngAfterViewInit() {
        this.ngZone.runOutsideAngular(() => {
            this.createResizeObserver(this.gridster.nativeElement)
                .pipe(debounceTime(100), takeUntil(this.ngUnsubscribe$))
                .subscribe(() => {
                if (this.config.api && this.config.api.resize) {
                    this.config.api.resize();
                }
                this.thyResizeChange.emit();
            });
        });
    }
    ngOnChanges(changes) {
        if (!changes.thyWidgets?.firstChange) {
            this.widgetGridsterItems = this.buildWidgetGridsterItems(this.widgets);
        }
        if (!changes.thyDraggable?.firstChange) {
            this.setDraggable(this.thyDraggable);
            undefined;
        }
    }
    trackBy(index, item) {
        return item.widget?._id || index;
    }
    createResizeObserver(element) {
        return typeof ResizeObserver === 'undefined'
            ? of(null)
            : new Observable((observer) => {
                const resize = new ResizeObserver((entries) => {
                    observer.next(entries);
                });
                resize.observe(element);
                return () => {
                    resize.disconnect();
                };
            });
    }
    buildWidgetGridsterItems(widgets) {
        return (widgets || []).map((widget) => {
            const widgetView = this.thyWidgetViews[widget.type];
            const gridsterItem = {
                x: widget.position?.x,
                y: widget.position?.y,
                cols: widget.size.cols,
                rows: widget.size.rows,
                minItemCols: widget.minSize?.cols,
                minItemRows: widget.minSize?.rows,
                outlet: widgetView?.outlet || widgetView,
                outletContext: {
                    ...widgetView?.context,
                    widget
                },
                widget
            };
            return gridsterItem;
        });
    }
    setDraggable(draggable) {
        if (draggable) {
            this.config = {
                ...this.config,
                minRows: 12,
                draggable: {
                    enabled: true
                },
                resizable: {
                    enabled: true
                },
                displayGrid: DisplayGrid.Always
            };
        }
        else {
            this.config = {
                ...this.config,
                minRows: 1,
                draggable: {
                    enabled: false
                },
                resizable: {
                    enabled: false
                },
                displayGrid: DisplayGrid.None
            };
        }
        this.cdr.markForCheck();
    }
    ngOnDestroy() {
        this.ngUnsubscribe$.next();
        this.ngUnsubscribe$.complete();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.2.3", ngImport: i0, type: ThyDashboardComponent, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "17.2.3", type: ThyDashboardComponent, isStandalone: true, selector: "thy-dashboard", inputs: { thyWidgetViews: "thyWidgetViews", thyDraggable: "thyDraggable", thyWidgets: "thyWidgets" }, outputs: { thyWidgetsChange: "thyWidgetsChange", thyResizeChange: "thyResizeChange" }, host: { classAttribute: "thy-dashboard" }, viewQueries: [{ propertyName: "gridster", first: true, predicate: ["gridster"], descendants: true, read: ElementRef, static: true }], usesOnChanges: true, ngImport: i0, template: "<gridster #gridster class=\"dashboard-gridster\" [options]=\"config\">\n  <gridster-item class=\"dashboard-girdster-item\" [item]=\"gridsterItem\" *ngFor=\"let gridsterItem of widgetGridsterItems; trackBy: trackBy\">\n    <ng-container *thyViewOutlet=\"gridsterItem.outlet; context: gridsterItem.outletContext\"> </ng-container>\n  </gridster-item>\n  <div class=\"empty-block\" [style.top.px]=\"gridster.rows * 128\"></div>\n</gridster>\n", dependencies: [{ kind: "component", type: GridsterComponent, selector: "gridster", inputs: ["options"] }, { kind: "directive", type: NgFor, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "component", type: GridsterItemComponent, selector: "gridster-item", inputs: ["item"], outputs: ["itemInit", "itemChange", "itemResize"] }, { kind: "directive", type: ThyViewOutletDirective, selector: "[thyViewOutlet]", inputs: ["thyViewOutlet", "thyViewOutletContext"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.2.3", ngImport: i0, type: ThyDashboardComponent, decorators: [{
            type: Component,
            args: [{ selector: 'thy-dashboard', changeDetection: ChangeDetectionStrategy.OnPush, host: { class: 'thy-dashboard' }, standalone: true, imports: [GridsterComponent, NgFor, GridsterItemComponent, ThyViewOutletDirective], template: "<gridster #gridster class=\"dashboard-gridster\" [options]=\"config\">\n  <gridster-item class=\"dashboard-girdster-item\" [item]=\"gridsterItem\" *ngFor=\"let gridsterItem of widgetGridsterItems; trackBy: trackBy\">\n    <ng-container *thyViewOutlet=\"gridsterItem.outlet; context: gridsterItem.outletContext\"> </ng-container>\n  </gridster-item>\n  <div class=\"empty-block\" [style.top.px]=\"gridster.rows * 128\"></div>\n</gridster>\n" }]
        }], ctorParameters: () => [{ type: i0.ChangeDetectorRef }, { type: i0.NgZone }], propDecorators: { thyWidgetViews: [{
                type: Input
            }], thyDraggable: [{
                type: Input
            }], thyWidgets: [{
                type: Input
            }], thyWidgetsChange: [{
                type: Output
            }], thyResizeChange: [{
                type: Output
            }], gridster: [{
                type: ViewChild,
                args: ['gridster', { static: true, read: ElementRef }]
            }] } });

const TETHYS_MODULES = [ThyTooltipModule, ThyIconModule, ThyActionModule, ThySharedModule];
class ThyProDashboardModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.2.3", ngImport: i0, type: ThyProDashboardModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "17.2.3", ngImport: i0, type: ThyProDashboardModule, imports: [ThyTooltipModule, ThyIconModule, ThyActionModule, ThySharedModule, RouterModule,
            CommonModule,
            GridsterModule,
            ThyDashboardComponent,
            ThyDashboardWidgetHeaderComponent,
            ThyDashboardWidgetBodyComponent], exports: [ThyDashboardComponent, ThyDashboardWidgetHeaderComponent, ThyDashboardWidgetBodyComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "17.2.3", ngImport: i0, type: ThyProDashboardModule, imports: [TETHYS_MODULES, RouterModule,
            CommonModule,
            GridsterModule,
            ThyDashboardComponent,
            ThyDashboardWidgetHeaderComponent] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.2.3", ngImport: i0, type: ThyProDashboardModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        ...TETHYS_MODULES,
                        RouterModule,
                        CommonModule,
                        GridsterModule,
                        ThyDashboardComponent,
                        ThyDashboardWidgetHeaderComponent,
                        ThyDashboardWidgetBodyComponent
                    ],
                    exports: [ThyDashboardComponent, ThyDashboardWidgetHeaderComponent, ThyDashboardWidgetBodyComponent],
                    providers: []
                }]
        }] });

class ThyDashboardWidgetComponent {
    set widget(value) {
        this._widget = value;
    }
    get widget() {
        return this._widget;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.2.3", ngImport: i0, type: ThyDashboardWidgetComponent, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "17.2.3", type: ThyDashboardWidgetComponent, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.2.3", ngImport: i0, type: ThyDashboardWidgetComponent, decorators: [{
            type: Directive
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { ThyDashboardComponent, ThyDashboardWidgetBodyComponent, ThyDashboardWidgetComponent, ThyDashboardWidgetHeaderComponent, ThyProDashboardModule };
//# sourceMappingURL=tethys-pro-dashboard.mjs.map
