import { NgIf, NgTemplateOutlet, AsyncPipe, NgClass, NgFor, CommonModule } from '@angular/common';
import * as i0 from '@angular/core';
import { EventEmitter, Component, ChangeDetectionStrategy, Input, Output, ViewChildren, ContentChild, NgModule } from '@angular/core';
import * as i2 from '@angular/router';
import { RouterLinkActive, RouterLink, RouterOutlet, RouterModule } from '@angular/router';
import { ThyIcon, ThyIconModule } from 'ngx-tethys/icon';
import * as i3 from 'ngx-tethys/layout';
import { ThyLayoutModule } from 'ngx-tethys/layout';
import * as i3$2 from 'ngx-tethys/menu';
import { ThyMenuModule, ThyMenu } from 'ngx-tethys/menu';
import * as i3$1 from 'ngx-tethys/action';
import { ThyActionModule } from 'ngx-tethys/action';
import { ThyAvatarModule } from 'ngx-tethys/avatar';
import { mixinUnsubscribe, MixinBase, InputBoolean } from 'ngx-tethys/core';
import * as i4 from 'ngx-tethys/tooltip';
import { ThyTooltipModule } from 'ngx-tethys/tooltip';
import * as i1 from '@tethys/pro/core';
import { THY_SITE_SETTINGS_PROVIDER } from '@tethys/pro/core';
import { __decorate } from 'tslib';
import * as i4$1 from 'ngx-tethys/popover';
import { ThyPopoverDirective, ThyPopoverModule } from 'ngx-tethys/popover';

class ThyProHeaderComponent extends mixinUnsubscribe(MixinBase) {
    constructor(globalStore) {
        super();
        this.globalStore = globalStore;
        this.collapsedChange = new EventEmitter();
        this.isCollapsed = false;
        this.title$ = this.globalStore.select((state) => state.activeMenu);
    }
    ngOnInit() { }
    changeCollapse() {
        this.isCollapsed = !this.isCollapsed;
        this.collapsedChange.emit(this.isCollapsed);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.2.3", ngImport: i0, type: ThyProHeaderComponent, deps: [{ token: i1.ThyGlobalStore }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "17.2.3", type: ThyProHeaderComponent, isStandalone: true, selector: "thy-pro-header", inputs: { headerRightContentTemplate: "headerRightContentTemplate" }, outputs: { collapsedChange: "collapsedChange" }, host: { classAttribute: "thy-pro-header" }, usesInheritance: true, ngImport: i0, template: "<thy-header thyDivided=\"true\">\n  <ng-template #headerTitle>\n    <a\n      class=\"ml-n2\"\n      thyAction\n      href=\"javascript:;\"\n      [thyTooltip]=\"isCollapsed ? '\u5C55\u5F00' : '\u6536\u8D77'\"\n      [thyIcon]=\"isCollapsed ? 'float-left' : 'float-right'\"\n      (click)=\"changeCollapse()\"\n    ></a>\n    <span class=\"title-name ml-1\">{{ (title$ | async)?.data?.title }}</span>\n  </ng-template>\n  <ng-template #headerOperation>\n    <ng-container *ngIf=\"headerRightContentTemplate\" [ngTemplateOutlet]=\"headerRightContentTemplate\"></ng-container>\n    <ng-container *ngIf=\"!headerRightContentTemplate\">\n      <thy-actions thySize=\"xs\">\n        <a href=\"javascript:;\" thyTooltip=\"\u901A\u77E5\" thyAction thyIcon=\"bell\"></a>\n        <a href=\"javascript:;\" thyTooltip=\"\u5E2E\u52A9\" thyAction>\n          <thy-icon thyIconName=\"question-circle\"></thy-icon>\n        </a>\n        <a href=\"javascript:;\" thyTooltip=\"\u8BBE\u7F6E\" thyAction>\n          <thy-icon thyIconName=\"settings\"></thy-icon>\n        </a>\n      </thy-actions>\n      <!-- <thy-avatar class=\"current-user\" [thyName]=\"globalStore.user.name\" thySize=\"sm\" [thySrc]=\"globalStore.user.name\"> </thy-avatar> -->\n    </ng-container>\n  </ng-template>\n</thy-header>\n", dependencies: [{ kind: "ngmodule", type: ThyLayoutModule }, { kind: "component", type: i3.ThyHeader, selector: "thy-header", inputs: ["thyTitle", "thyIconPrefix", "thyIcon"] }, { kind: "ngmodule", type: ThyActionModule }, { kind: "component", type: i3$1.ThyAction, selector: "thy-action, [thyAction]", inputs: ["thyType", "thyIcon", "thyActionIcon", "thyActive", "thyActionActive", "thyTheme", "thyHoverIcon", "thyDisabled"] }, { kind: "component", type: i3$1.ThyActions, selector: "thy-actions", inputs: ["thySize"] }, { kind: "ngmodule", type: ThyTooltipModule }, { kind: "directive", type: i4.ThyTooltipDirective, selector: "[thyTooltip],[thy-tooltip]", inputs: ["thyTooltip", "thyTooltipPlacement", "thyTooltipClass", "thyTooltipShowDelay", "thyTooltipHideDelay", "thyTooltipTrigger", "thyTooltipDisabled", "thyTooltipTemplateContext", "thyTooltipOffset", "thyTooltipPin"], exportAs: ["thyTooltip"] }, { kind: "directive", type: NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "component", type: ThyIcon, selector: "thy-icon, [thy-icon]", inputs: ["thyIconType", "thyTwotoneColor", "thyIconName", "thyIconRotate", "thyIconSet", "thyIconLegging", "thyIconLinearGradient"] }, { kind: "pipe", type: AsyncPipe, name: "async" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.2.3", ngImport: i0, type: ThyProHeaderComponent, decorators: [{
            type: Component,
            args: [{ selector: 'thy-pro-header', changeDetection: ChangeDetectionStrategy.OnPush, host: {
                        class: 'thy-pro-header'
                    }, standalone: true, imports: [ThyLayoutModule, ThyActionModule, ThyTooltipModule, NgIf, NgTemplateOutlet, ThyIcon, AsyncPipe], template: "<thy-header thyDivided=\"true\">\n  <ng-template #headerTitle>\n    <a\n      class=\"ml-n2\"\n      thyAction\n      href=\"javascript:;\"\n      [thyTooltip]=\"isCollapsed ? '\u5C55\u5F00' : '\u6536\u8D77'\"\n      [thyIcon]=\"isCollapsed ? 'float-left' : 'float-right'\"\n      (click)=\"changeCollapse()\"\n    ></a>\n    <span class=\"title-name ml-1\">{{ (title$ | async)?.data?.title }}</span>\n  </ng-template>\n  <ng-template #headerOperation>\n    <ng-container *ngIf=\"headerRightContentTemplate\" [ngTemplateOutlet]=\"headerRightContentTemplate\"></ng-container>\n    <ng-container *ngIf=\"!headerRightContentTemplate\">\n      <thy-actions thySize=\"xs\">\n        <a href=\"javascript:;\" thyTooltip=\"\u901A\u77E5\" thyAction thyIcon=\"bell\"></a>\n        <a href=\"javascript:;\" thyTooltip=\"\u5E2E\u52A9\" thyAction>\n          <thy-icon thyIconName=\"question-circle\"></thy-icon>\n        </a>\n        <a href=\"javascript:;\" thyTooltip=\"\u8BBE\u7F6E\" thyAction>\n          <thy-icon thyIconName=\"settings\"></thy-icon>\n        </a>\n      </thy-actions>\n      <!-- <thy-avatar class=\"current-user\" [thyName]=\"globalStore.user.name\" thySize=\"sm\" [thySrc]=\"globalStore.user.name\"> </thy-avatar> -->\n    </ng-container>\n  </ng-template>\n</thy-header>\n" }]
        }], ctorParameters: () => [{ type: i1.ThyGlobalStore }], propDecorators: { headerRightContentTemplate: [{
                type: Input
            }], collapsedChange: [{
                type: Output
            }] } });

const menusMap = new Map();
const filterEmptyRoutePath = (route, menuGroup) => {
    if (!route || !route.children)
        return;
    return route.children.filter((item) => {
        if (item.path) {
            const routeMap = menusMap.get(route.path);
            let rootMenu = route;
            if (routeMap && routeMap.rootMenu && routeMap.rootMenu.path) {
                rootMenu = routeMap.rootMenu;
            }
            menusMap.set(item.path, { ...item, rootMenu });
            if (item.children) {
                item.children = filterEmptyRoutePath(item, route);
            }
        }
        return item.path;
    });
};

class ThyProSidebarComponent {
    set isCollapsed(value) {
        this.sidebarCollapsed = value;
        if (this.currentRootMenuGroup) {
            this.changeMenuGroupCollapsed(this.currentRootMenuGroup, false);
        }
    }
    constructor(globalStore) {
        this.globalStore = globalStore;
    }
    ngOnInit() {
        this.initCurrentMenuGroup();
    }
    getMenuGroupElement(event) {
        if (this.isCollapsed) {
            this.menuGroupElement = event.target;
        }
    }
    initCurrentMenuGroup() {
        // 初始化的时候，根据 ThyGlobalStore 的 activeMenu 获取 menuGroup 的路由，设置高亮状态
        const activeRoute = this.globalStore.snapshot.activeMenu;
        this.getCurrentRootMenuGroup(activeRoute);
    }
    setActiveMenu(menuGroup, activeLinkMenu) {
        this.menuPopovers?.forEach((item) => {
            item.popoverOpened && item.hide();
        });
        this.changeMenuGroupCollapsed(menuGroup, false);
        this.getCurrentRootMenuGroup(activeLinkMenu);
        this.globalStore.pureUpdateActiveMenu(activeLinkMenu);
    }
    menuGroupCollapsedChange(isCollapsed, menuGroup) {
        this.changeMenuGroupCollapsed(menuGroup, isCollapsed);
    }
    changeMenuGroupCollapsed(menuGroup, isCollapsed) {
        menuGroup.isCollapsed = isCollapsed;
    }
    getCurrentRootMenuGroup(activeRoute) {
        const activeRouteWidthParent = menusMap.get(activeRoute?.path);
        this.currentRootMenuGroup = activeRouteWidthParent?.rootMenu;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.2.3", ngImport: i0, type: ThyProSidebarComponent, deps: [{ token: i1.ThyGlobalStore }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "17.2.3", type: ThyProSidebarComponent, isStandalone: true, selector: "thy-pro-sidebar", inputs: { menus: "menus", logo: "logo", title: "title", isCollapsed: "isCollapsed", headerTemplate: "headerTemplate", menuTemplate: "menuTemplate", footerTemplate: "footerTemplate" }, host: { classAttribute: "thy-layout thy-pro-sidebar" }, viewQueries: [{ propertyName: "menuPopovers", predicate: ThyPopoverDirective, descendants: true }], ngImport: i0, template: "<thy-sidebar-header class=\"thy-pro-sidebar-header\" [ngClass]=\"{ 'justify-content-center': sidebarCollapsed }\">\n  <ng-container\n    *ngIf=\"headerTemplate\"\n    [ngTemplateOutlet]=\"headerTemplate\"\n    [ngTemplateOutletContext]=\"{ value: { logo: this.logo, title: this.title } }\"\n  ></ng-container>\n  <ng-container *ngIf=\"!headerTemplate\">\n    <img class=\"header-logo\" [src]=\"logo\" />\n    <span class=\"header-title text-truncate\" *ngIf=\"!sidebarCollapsed\">{{ title }}</span>\n  </ng-container>\n</thy-sidebar-header>\n<thy-sidebar-content>\n  <ng-container *ngIf=\"menuTemplate\" [ngTemplateOutlet]=\"menuTemplate\" [ngTemplateOutletContext]=\"{ menus }\"> </ng-container>\n  <ng-container *ngIf=\"!menuTemplate\">\n    <thy-menu [thyCollapsed]=\"sidebarCollapsed\" thyTheme=\"dark\">\n      <ng-container *ngFor=\"let menu of menus\">\n        <thy-menu-group\n          [thyShowIcon]=\"true\"\n          [thyCollapsed]=\"menu.isCollapsed || false\"\n          [thyCollapsible]=\"true\"\n          [thyIcon]=\"menu.data?.icon!\"\n          [thyTitle]=\"menu.data?.title!\"\n          [thyPopover]=\"collapsedMenuList\"\n          [thyTrigger]=\"'hover'\"\n          [thyDisabled]=\"!sidebarCollapsed\"\n          (thyCollapsedChange)=\"menuGroupCollapsedChange($event, menu)\"\n          class=\"thy-pro-sidebar-menu-group\"\n          [class.active]=\"sidebarCollapsed && currentRootMenuGroup === menu\"\n          (mouseenter)=\"getMenuGroupElement($event)\"\n          [thyConfig]=\"{\n            placement: 'rightTop',\n            origin: menuGroupElement,\n            panelClass: 'thy-menu-grop-popover',\n            initialState: { menu: this.menu }\n          }\"\n        >\n          <ng-template [ngTemplateOutlet]=\"menuItems\" [ngTemplateOutletContext]=\"{ $implicit: menu, path: menu.path }\"> </ng-template>\n        </thy-menu-group>\n      </ng-container>\n    </thy-menu>\n  </ng-container>\n</thy-sidebar-content>\n\n<ng-template #menuItems let-menu let-path=\"path\">\n  <ng-container *ngFor=\"let menuItem of menu.children\">\n    <a\n      thyMenuItem\n      *ngIf=\"!menuItem.children?.length\"\n      class=\"ml-2\"\n      [routerLink]=\"[path, menuItem?.path]\"\n      (click)=\"setActiveMenu(menu, menuItem)\"\n      routerLinkActive=\"active\"\n    >\n      <span thyMenuItemName> {{ menuItem.data?.title }} </span>\n    </a>\n    <ng-template\n      *ngIf=\"menuItem.children?.length\"\n      [ngTemplateOutlet]=\"submenuGroup\"\n      [ngTemplateOutletContext]=\"{ $implicit: menuItem, path: path + '/' + menuItem.path }\"\n    >\n    </ng-template>\n  </ng-container>\n</ng-template>\n\n<ng-template #submenuGroup let-menuItem let-path=\"path\">\n  <thy-menu-group class=\"px-2 thy-pro-sidebar-submenu\" [thyCollapsed]=\"false\" [thyCollapsible]=\"true\" [thyTitle]=\"menuItem?.data.title!\">\n    <ng-template [ngTemplateOutlet]=\"menuItems\" [ngTemplateOutletContext]=\"{ $implicit: menuItem, path: path }\"> </ng-template>\n  </thy-menu-group>\n</ng-template>\n\n<ng-template #collapsedMenuList let-value>\n  <thy-menu thyTheme=\"dark\" class=\"action-menu\">\n    <ng-template [ngTemplateOutlet]=\"menuItems\" [ngTemplateOutletContext]=\"{ $implicit: value.menu, path: value.menu.path }\"></ng-template>\n  </thy-menu>\n</ng-template>\n\n<thy-sidebar-footer>\n  <ng-container *ngIf=\"footerTemplate\" [ngTemplateOutlet]=\"footerTemplate\"></ng-container>\n</thy-sidebar-footer>\n", dependencies: [{ kind: "ngmodule", type: ThyLayoutModule }, { kind: "component", type: i3.ThySidebarHeader, selector: "thy-sidebar-header", inputs: ["thyTitle"] }, { kind: "component", type: i3.ThySidebarContent, selector: "thy-sidebar-content" }, { kind: "component", type: i3.ThySidebarFooter, selector: "thy-sidebar-footer" }, { kind: "directive", type: NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "ngmodule", type: ThyMenuModule }, { kind: "component", type: i3$2.ThyMenu, selector: "thy-menu,[thy-menu],[thyMenu]", inputs: ["thyTheme", "thyCollapsed"] }, { kind: "component", type: i3$2.ThyMenuGroup, selector: "thy-menu-group,[thy-menu-group],[thyMenuGroup]", inputs: ["thyTitle", "thyExpand", "thyCollapsed", "thyCollapsible", "thyShowIcon", "thyIcon", "thyActionIcon", "thyShowAction", "thyActionStopPropagation", "thyActionMenu"], outputs: ["thyOnActionClick", "thyCollapsedChange"] }, { kind: "component", type: i3$2.ThyMenuItem, selector: "thy-menu-item,[thy-menu-item],[thyMenuItem]", inputs: ["thyIcon"] }, { kind: "component", type: i3$2.ThyMenuItemName, selector: "thy-menu-item-name,[thy-menu-item-name],[thyMenuItemName]", inputs: ["thyOverflowEllipsis"] }, { kind: "directive", type: NgFor, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "ngmodule", type: ThyPopoverModule }, { kind: "directive", type: i4$1.ThyPopoverDirective, selector: "[thyPopover]", inputs: ["thyPopover", "thyTrigger", "thyPlacement", "thyOffset", "thyConfig", "thyShowDelay", "thyHideDelay", "thyAutoAdaptive", "thyDisabled"] }, { kind: "directive", type: RouterLinkActive, selector: "[routerLinkActive]", inputs: ["routerLinkActiveOptions", "ariaCurrentWhenActive", "routerLinkActive"], outputs: ["isActiveChange"], exportAs: ["routerLinkActive"] }, { kind: "directive", type: RouterLink, selector: "[routerLink]", inputs: ["target", "queryParams", "fragment", "queryParamsHandling", "state", "info", "relativeTo", "preserveFragment", "skipLocationChange", "replaceUrl", "routerLink"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
__decorate([
    InputBoolean()
], ThyProSidebarComponent.prototype, "isCollapsed", null);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.2.3", ngImport: i0, type: ThyProSidebarComponent, decorators: [{
            type: Component,
            args: [{ selector: 'thy-pro-sidebar', changeDetection: ChangeDetectionStrategy.OnPush, host: {
                        class: 'thy-layout thy-pro-sidebar'
                    }, standalone: true, imports: [ThyLayoutModule, NgClass, NgIf, NgTemplateOutlet, ThyMenuModule, NgFor, ThyPopoverModule, RouterLinkActive, RouterLink], template: "<thy-sidebar-header class=\"thy-pro-sidebar-header\" [ngClass]=\"{ 'justify-content-center': sidebarCollapsed }\">\n  <ng-container\n    *ngIf=\"headerTemplate\"\n    [ngTemplateOutlet]=\"headerTemplate\"\n    [ngTemplateOutletContext]=\"{ value: { logo: this.logo, title: this.title } }\"\n  ></ng-container>\n  <ng-container *ngIf=\"!headerTemplate\">\n    <img class=\"header-logo\" [src]=\"logo\" />\n    <span class=\"header-title text-truncate\" *ngIf=\"!sidebarCollapsed\">{{ title }}</span>\n  </ng-container>\n</thy-sidebar-header>\n<thy-sidebar-content>\n  <ng-container *ngIf=\"menuTemplate\" [ngTemplateOutlet]=\"menuTemplate\" [ngTemplateOutletContext]=\"{ menus }\"> </ng-container>\n  <ng-container *ngIf=\"!menuTemplate\">\n    <thy-menu [thyCollapsed]=\"sidebarCollapsed\" thyTheme=\"dark\">\n      <ng-container *ngFor=\"let menu of menus\">\n        <thy-menu-group\n          [thyShowIcon]=\"true\"\n          [thyCollapsed]=\"menu.isCollapsed || false\"\n          [thyCollapsible]=\"true\"\n          [thyIcon]=\"menu.data?.icon!\"\n          [thyTitle]=\"menu.data?.title!\"\n          [thyPopover]=\"collapsedMenuList\"\n          [thyTrigger]=\"'hover'\"\n          [thyDisabled]=\"!sidebarCollapsed\"\n          (thyCollapsedChange)=\"menuGroupCollapsedChange($event, menu)\"\n          class=\"thy-pro-sidebar-menu-group\"\n          [class.active]=\"sidebarCollapsed && currentRootMenuGroup === menu\"\n          (mouseenter)=\"getMenuGroupElement($event)\"\n          [thyConfig]=\"{\n            placement: 'rightTop',\n            origin: menuGroupElement,\n            panelClass: 'thy-menu-grop-popover',\n            initialState: { menu: this.menu }\n          }\"\n        >\n          <ng-template [ngTemplateOutlet]=\"menuItems\" [ngTemplateOutletContext]=\"{ $implicit: menu, path: menu.path }\"> </ng-template>\n        </thy-menu-group>\n      </ng-container>\n    </thy-menu>\n  </ng-container>\n</thy-sidebar-content>\n\n<ng-template #menuItems let-menu let-path=\"path\">\n  <ng-container *ngFor=\"let menuItem of menu.children\">\n    <a\n      thyMenuItem\n      *ngIf=\"!menuItem.children?.length\"\n      class=\"ml-2\"\n      [routerLink]=\"[path, menuItem?.path]\"\n      (click)=\"setActiveMenu(menu, menuItem)\"\n      routerLinkActive=\"active\"\n    >\n      <span thyMenuItemName> {{ menuItem.data?.title }} </span>\n    </a>\n    <ng-template\n      *ngIf=\"menuItem.children?.length\"\n      [ngTemplateOutlet]=\"submenuGroup\"\n      [ngTemplateOutletContext]=\"{ $implicit: menuItem, path: path + '/' + menuItem.path }\"\n    >\n    </ng-template>\n  </ng-container>\n</ng-template>\n\n<ng-template #submenuGroup let-menuItem let-path=\"path\">\n  <thy-menu-group class=\"px-2 thy-pro-sidebar-submenu\" [thyCollapsed]=\"false\" [thyCollapsible]=\"true\" [thyTitle]=\"menuItem?.data.title!\">\n    <ng-template [ngTemplateOutlet]=\"menuItems\" [ngTemplateOutletContext]=\"{ $implicit: menuItem, path: path }\"> </ng-template>\n  </thy-menu-group>\n</ng-template>\n\n<ng-template #collapsedMenuList let-value>\n  <thy-menu thyTheme=\"dark\" class=\"action-menu\">\n    <ng-template [ngTemplateOutlet]=\"menuItems\" [ngTemplateOutletContext]=\"{ $implicit: value.menu, path: value.menu.path }\"></ng-template>\n  </thy-menu>\n</ng-template>\n\n<thy-sidebar-footer>\n  <ng-container *ngIf=\"footerTemplate\" [ngTemplateOutlet]=\"footerTemplate\"></ng-container>\n</thy-sidebar-footer>\n" }]
        }], ctorParameters: () => [{ type: i1.ThyGlobalStore }], propDecorators: { menus: [{
                type: Input
            }], logo: [{
                type: Input
            }], title: [{
                type: Input
            }], isCollapsed: [{
                type: Input
            }], headerTemplate: [{
                type: Input
            }], menuTemplate: [{
                type: Input
            }], footerTemplate: [{
                type: Input
            }], menuPopovers: [{
                type: ViewChildren,
                args: [ThyPopoverDirective]
            }] } });

class ThyProLayoutComponent {
    /**
     * 菜单数据
     */
    set thyMenus(value) {
        this.menus = value;
    }
    constructor(globalStore, router, route) {
        this.globalStore = globalStore;
        this.router = router;
        this.route = route;
        /**
         *  menu 菜单的头部点击事件
         */
        this.menuHeaderClick = new EventEmitter();
        this.isCollapsed = false;
        const routes = this.router.config[1];
        const filterRoutes = filterEmptyRoutePath(routes);
        if (routes.children?.length) {
            this.globalStore.initializeMenus(filterRoutes);
        }
        // 获取路由信息，初始化到 ThyGlobalStore 的 activeMenu
        this.globalStore.pureUpdateActiveMenu(this.route.firstChild?.firstChild?.routeConfig);
    }
    ngOnInit() {
        this.menus = this.menus && this.menus.length ? this.menus : this.globalStore.snapshot.menus;
    }
    collapsedChange(isCollapsed) {
        this.isCollapsed = isCollapsed;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.2.3", ngImport: i0, type: ThyProLayoutComponent, deps: [{ token: i1.ThyGlobalStore }, { token: i2.Router }, { token: i2.ActivatedRoute }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "17.2.3", type: ThyProLayoutComponent, isStandalone: true, selector: "thy-pro-layout", inputs: { thyTitle: "thyTitle", thyLogo: "thyLogo", thyMenus: "thyMenus" }, outputs: { menuHeaderClick: "menuHeaderClick" }, host: { classAttribute: "thy-layout thy-layout--has-sidebar thy-pro-layout" }, queries: [{ propertyName: "menuHeaderTemplate", first: true, predicate: ["menuHeader"], descendants: true }, { propertyName: "menuTemplate", first: true, predicate: ["menuList"], descendants: true }, { propertyName: "menuFooterTemplate", first: true, predicate: ["menuFooter"], descendants: true }, { propertyName: "headerRightContentTemplate", first: true, predicate: ["headerRightContent"], descendants: true }, { propertyName: "footerTemplate", first: true, predicate: ["footer"], descendants: true }], ngImport: i0, template: "<thy-sidebar [thyCollapsible]=\"true\" [thyCollapsed]=\"isCollapsed\" [thyCollapsedWidth]=\"61\" [thyTrigger]=\"null\">\n  <thy-pro-sidebar\n    [menus]=\"menus\"\n    [logo]=\"thyLogo\"\n    [title]=\"thyTitle\"\n    [isCollapsed]=\"isCollapsed\"\n    [headerTemplate]=\"menuHeaderTemplate\"\n    [menuTemplate]=\"menuTemplate\"\n    [footerTemplate]=\"menuFooterTemplate\"\n  >\n  </thy-pro-sidebar>\n</thy-sidebar>\n<thy-layout>\n  <thy-pro-header [headerRightContentTemplate]=\"headerRightContentTemplate\" (collapsedChange)=\"collapsedChange($event)\"></thy-pro-header>\n  <thy-layout>\n    <thy-header thySize=\"sm\" thyTitle=\"\u4E8C\u7EA7\u6807\u9898\" thyDivided=\"true\"></thy-header>\n    <thy-content>\n      <router-outlet></router-outlet>\n    </thy-content>\n    <thy-sidebar-footer>\n      <ng-container *ngIf=\"footerTemplate\" [ngTemplateOutlet]=\"footerTemplate\"></ng-container>\n    </thy-sidebar-footer>\n  </thy-layout>\n</thy-layout>\n", dependencies: [{ kind: "ngmodule", type: ThyLayoutModule }, { kind: "component", type: i3.ThyLayout, selector: "thy-layout" }, { kind: "component", type: i3.ThyHeader, selector: "thy-header", inputs: ["thyTitle", "thyIconPrefix", "thyIcon"] }, { kind: "component", type: i3.ThyContent, selector: "thy-content" }, { kind: "component", type: i3.ThySidebar, selector: "thy-sidebar", inputs: ["thyDraggable", "thyDragMaxWidth", "thyDragMinWidth", "thyTrigger", "thyCollapsible", "thyCollapsed", "thyCollapsedWidth", "thyDefaultWidth"], outputs: ["thyCollapsedChange", "thyDragWidthChange"] }, { kind: "component", type: i3.ThySidebarFooter, selector: "thy-sidebar-footer" }, { kind: "component", type: ThyProSidebarComponent, selector: "thy-pro-sidebar", inputs: ["menus", "logo", "title", "isCollapsed", "headerTemplate", "menuTemplate", "footerTemplate"] }, { kind: "component", type: ThyProHeaderComponent, selector: "thy-pro-header", inputs: ["headerRightContentTemplate"], outputs: ["collapsedChange"] }, { kind: "directive", type: RouterOutlet, selector: "router-outlet", inputs: ["name"], outputs: ["activate", "deactivate", "attach", "detach"], exportAs: ["outlet"] }, { kind: "directive", type: NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.2.3", ngImport: i0, type: ThyProLayoutComponent, decorators: [{
            type: Component,
            args: [{ selector: 'thy-pro-layout', changeDetection: ChangeDetectionStrategy.OnPush, host: {
                        class: 'thy-layout thy-layout--has-sidebar thy-pro-layout'
                    }, standalone: true, imports: [ThyLayoutModule, ThyProSidebarComponent, ThyProHeaderComponent, RouterOutlet, NgIf, NgTemplateOutlet], template: "<thy-sidebar [thyCollapsible]=\"true\" [thyCollapsed]=\"isCollapsed\" [thyCollapsedWidth]=\"61\" [thyTrigger]=\"null\">\n  <thy-pro-sidebar\n    [menus]=\"menus\"\n    [logo]=\"thyLogo\"\n    [title]=\"thyTitle\"\n    [isCollapsed]=\"isCollapsed\"\n    [headerTemplate]=\"menuHeaderTemplate\"\n    [menuTemplate]=\"menuTemplate\"\n    [footerTemplate]=\"menuFooterTemplate\"\n  >\n  </thy-pro-sidebar>\n</thy-sidebar>\n<thy-layout>\n  <thy-pro-header [headerRightContentTemplate]=\"headerRightContentTemplate\" (collapsedChange)=\"collapsedChange($event)\"></thy-pro-header>\n  <thy-layout>\n    <thy-header thySize=\"sm\" thyTitle=\"\u4E8C\u7EA7\u6807\u9898\" thyDivided=\"true\"></thy-header>\n    <thy-content>\n      <router-outlet></router-outlet>\n    </thy-content>\n    <thy-sidebar-footer>\n      <ng-container *ngIf=\"footerTemplate\" [ngTemplateOutlet]=\"footerTemplate\"></ng-container>\n    </thy-sidebar-footer>\n  </thy-layout>\n</thy-layout>\n" }]
        }], ctorParameters: () => [{ type: i1.ThyGlobalStore }, { type: i2.Router }, { type: i2.ActivatedRoute }], propDecorators: { thyTitle: [{
                type: Input
            }], thyLogo: [{
                type: Input
            }], thyMenus: [{
                type: Input
            }], menuHeaderClick: [{
                type: Output
            }], menuHeaderTemplate: [{
                type: ContentChild,
                args: ['menuHeader']
            }], menuTemplate: [{
                type: ContentChild,
                args: ['menuList']
            }], menuFooterTemplate: [{
                type: ContentChild,
                args: ['menuFooter']
            }], headerRightContentTemplate: [{
                type: ContentChild,
                args: ['headerRightContent']
            }], footerTemplate: [{
                type: ContentChild,
                args: ['footer']
            }] } });

const COMPONENTS = [ThyProHeaderComponent, ThyProLayoutComponent, ThyProSidebarComponent];
const TETHYS_MODULES = [
    ThyLayoutModule,
    ThyMenuModule,
    ThyIconModule,
    ThyPopoverModule,
    ThyActionModule,
    ThyAvatarModule,
    ThyTooltipModule
];
class ThyProLayoutModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.2.3", ngImport: i0, type: ThyProLayoutModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "17.2.3", ngImport: i0, type: ThyProLayoutModule, imports: [ThyLayoutModule,
            ThyMenuModule,
            ThyIconModule,
            ThyPopoverModule,
            ThyActionModule,
            ThyAvatarModule,
            ThyTooltipModule, RouterModule, CommonModule, ThyProHeaderComponent, ThyProLayoutComponent, ThyProSidebarComponent], exports: [ThyProHeaderComponent, ThyProLayoutComponent, ThyProSidebarComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "17.2.3", ngImport: i0, type: ThyProLayoutModule, providers: [THY_SITE_SETTINGS_PROVIDER, ThyMenu], imports: [TETHYS_MODULES, RouterModule, CommonModule, COMPONENTS] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.2.3", ngImport: i0, type: ThyProLayoutModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [...TETHYS_MODULES, RouterModule, CommonModule, ...COMPONENTS],
                    exports: [...COMPONENTS],
                    providers: [THY_SITE_SETTINGS_PROVIDER, ThyMenu]
                }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { ThyProHeaderComponent, ThyProLayoutComponent, ThyProLayoutModule, ThyProSidebarComponent };
//# sourceMappingURL=tethys-pro-layout.mjs.map
