import { ElementRef, EventEmitter, OnInit } from '@angular/core';
import Cropper from 'cropperjs';
import { ThyCropperOptions, ThyCropperShape, ThyCropperViewMode, thyCropDataChangeEvent } from './cropper.entity';
import * as i0 from "@angular/core";
export declare class ThyImageCropperComponent implements OnInit {
    cropperClass: boolean;
    image: ElementRef;
    /**
     * 图片资源
     */
    set imageSource(value: File | string);
    /**
     * 图片加载的错误提示
     * @default 图片加载错误
     */
    thyImageErrorMessage: string;
    /**
     * 图片裁剪模式
     */
    thyViewMode: ThyCropperViewMode;
    /**
     * 图片裁剪宽高比
     */
    thyAspectRatio: number;
    /**
     * 设置裁剪形状
     */
    thyShape: ThyCropperShape;
    /**
     * 设置放大缩小
     */
    set thyScale(value: number);
    /**
     * 设置旋转角度
     */
    set thyRotate(value: number);
    /**
     * 图片裁剪的数据更改(blob)
     * @default EventEmitter<thyCropDataChangeEvent>
     */
    thyCropDataChanged: EventEmitter<thyCropDataChangeEvent>;
    /**
     * 图片加载完毕事件
     * @default EventEmitter<boolean>
     */
    thyImageReady: EventEmitter<boolean>;
    loadingDone: boolean;
    cropper: Cropper | undefined;
    loadError: boolean;
    private imageFile;
    imageSrc: string;
    defaultCropperOptions: ThyCropperOptions;
    cropperOptions: ThyCropperOptions;
    scale: number;
    constructor();
    ngOnInit(): void;
    onLoad(event: Event): void;
    onError(event?: Event): void;
    crop: () => void;
    setImageSrc(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<ThyImageCropperComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<ThyImageCropperComponent, "thy-image-cropper", never, { "imageSource": { "alias": "thyImage"; "required": false; }; "thyImageErrorMessage": { "alias": "thyImageErrorMessage"; "required": false; }; "thyViewMode": { "alias": "thyViewMode"; "required": false; }; "thyAspectRatio": { "alias": "thyAspectRatio"; "required": false; }; "thyShape": { "alias": "thyShape"; "required": false; }; "thyScale": { "alias": "thyScale"; "required": false; }; "thyRotate": { "alias": "thyRotate"; "required": false; }; }, { "thyCropDataChanged": "thyCropDataChanged"; "thyImageReady": "thyImageReady"; }, never, never, true, never>;
}
//# sourceMappingURL=cropper.component.d.ts.map