import { EventEmitter, OnInit } from '@angular/core';
import { DomSanitizer, SafeUrl } from '@angular/platform-browser';
import * as i0 from "@angular/core";
/**
 * @internal
 */
export declare class ThyMediaPlayerBaseComponent implements OnInit {
    sanitizer: DomSanitizer;
    errorTips: {
        formatError: string;
        networkError: string;
    };
    showErrorTip: boolean;
    showMedia: boolean;
    errorTipText: string;
    set fileSrc(value: string | SafeUrl);
    get fileSrc(): string | SafeUrl;
    private internalFileSrc;
    /**
     * 媒体元数据被加载完成后触发 能拿到媒体尺寸、时长等
     */
    thyLoadedMetadata: EventEmitter<HTMLVideoElement | HTMLAudioElement>;
    constructor(sanitizer: DomSanitizer);
    ngOnInit(): void;
    onLoadedmetadata(event: Event): void;
    onCanPlay(): void;
    onError(event: Event): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<ThyMediaPlayerBaseComponent, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<ThyMediaPlayerBaseComponent, "[thyMediaPlayerBase]", never, {}, { "thyLoadedMetadata": "thyLoadedMetadata"; }, never, never, true, never>;
}
//# sourceMappingURL=media-base.component.d.ts.map